;autor yesma
;dla 32bit nie wszystkie sprawdzone

%if WORDSIZE = 64
%define LONG 8
%else
%define LONG 4
%endif

%define PT LONG

struc dirent
	.d_ino		resb LONG;
	.d_off		resb LONG;
	.d_reclen	resb 2;
	.d_name		resb 256
	.d_type		resb 6;
endstruc

struc pollfd
	.fd		resb 4;/* File descriptor to poll.  */
	.events		resb 2;/* Types of events poller cares about.  */
	.revents	resb 2;/* Types of events that actually occurred.  */
endstruc

struc timespec
	.tv_sec		resb LONG
	.tv_nsec	resb LONG
endstruc

struc timeval
	.tv_sec		resb LONG;     /* seconds */ long int
	.tv_usec	resb LONG;    /* microseconds */
endstruc

struc timezone
	.tz_minuteswest	resb 4;		/* Minutes west of GMT.  */
	.tz_dsttime	resb 4;		/* Nonzero if DST is ever in effect.  */
endstruc

struc sigaction
	.sa_sigaction	resb LONG	;adres procki do obsługi (int,siginfo *,void *)
	.sa_flags	resb LONG	;SA_SIGINFO
	.sa_restorer	resb LONG	;null during execution of the signal handler.
	.sa_mask	resb 4		;sa_mask gives a mask of signals which should be blocked
	.sa_maskrt	resb 4		;bity sygnalow od 32 do 64
endstruc

struc stack_t
	.ss_sp		resb LONG ;/* Signal stack pointer.  */
	.ss_flags	resb LONG
	.ss_size	resb LONG;
endstruc

struc siginfo_t
	.si_signo	resb LONG;
	.si_errno	resb 4;
	.si_code	resb 4;
	.si_pid		resb 4
	.si_uid		resb 4
	.si_status	resb LONG
	.si_utime	resb LONG
	.si_stime	resb LONG
			resb 32
endstruc

struc sigqui_info				;np sys_rt_sigqueueinfo [pid],SIGRT_4,sigqui
	.si_signo	resb LONG		;np SIGRT_4
	.si_code	resb LONG		;jak wysylasz to SI_QUEUE
	.si_pid		resb 4
	.si_uid		resb 4
	.si_value_int	resb 4			;miejsce na wartosc ktora mozesz wyslac do procesu lub 0
	.si_value_ptr	resb LONG		;pt do danych ktore wysylasz do procesu lub 0
			resb 4			;pad dla AMD64
endstruc

struc rt_info
	.si_signo	resb 4;
	.si_errno	resb 4;
	.si_code	resb LONG;
	.si_band	resb LONG		;sigio poolin poolout 
	.si_fd		resb LONG		;fd
endstruc

%if WORDSIZE = 64
struc sigcontext
		resb LONG;0
		resb LONG;0
		resb LONG;0
		resb LONG;2
		resb LONG;0
	.r8		resb LONG;
	.r9		resb LONG;
	.r10		resb LONG;
	.r11		resb LONG;zostaje zniszczony
	.r12		resb LONG;
	.r13		resb LONG;
	.r14		resb LONG;
	.r15		resb LONG;
	.rdi		resb LONG;000000000060032c
	.rsi		resb LONG;0000000000000000
	.rbp		resb LONG;
	.rbx		resb LONG;
	.rdx		resb LONG;
	.rax		resb LONG;fffffffffffffffc
	.rcx		resb LONG;ffffffffffffffff
	.rsp		resb LONG;00007fff78375950
	.rip		resb LONG;00000000004001ee
	.eflags		resb LONG;0000000000000202
	.cs		resb 2;0033
	.gs		resb 2;0000
	.fs		resb 2;0000
	.pad0		resb 2;0000
	.err		resb LONG;0
	.trapno		resb LONG;0
	.oldmask	resb LONG;0
	.cr2		resb LONG;0
	.fpstate	resb LONG;0
	.reserved1	resq LONG;0
endstruc
%else					;32bit
struc sigcontext

	.a resb LONG;0 ?
	.b resb LONG;0 ?
	.c resb LONG;0 ?
	.d resb LONG;02 ?
	.e resb LONG;0 ?

	.gs		resb 2
	.gsh		resb 2
	.fs		resb 2
	.fsh		resb 2
	.es		resb 2;007b
	.esh		resb 2;0000
	.ds		resb 2;007b
	.dsh		resb 2;0000

	.edi		resb LONG;F
	.esi		resb LONG;E
	.ebp		resb LONG;H
	.esp		resb PT;bfad8480 PT
	.ebx		resb LONG;B
	.edx		resb LONG;D
	.ecx		resb LONG;C
	.eax		resb LONG;fffffcff zniszczony

	.trapno		resb LONG;0
	.err		resb LONG;0
	.eip		resb PT;80480fb PT
	.cs		resb 2;0073
	.csh		resb 2;0000
	.eflags		resb LONG;200202
	.esp_at_signal	resb PT;bfad8480 PT
	.ss		resb 2;7b
	.ssh		resb 2;0000
	.fpstate	resb PT;0
	.oldmask	resb LONG;0
	.cr2		resb LONG;0
endstruc
%endif

struc sockaddr_in
	.sin_family	resb 2		; rodzina adresów
	.sin_port	resb 2		; numer portu
	.sin_addr	resb 4		; adres
			resb 8		; dopełnienie do 16 bajtów
endstruc

struc ethhdr
	.h_dest			resb 6
	.h_source		resb 6
	.h_proto		resb 2	;np ETH_P_IP ETH_P_ARP
endstruc

struc iphdr
	.ip_version		resb 1	;"Version4bit" "IHL4bit"
	.ip_tos			resb 1
	.ip_total_length	resb 2	;dlugosc calego datagramu
	.ip_id			resb 2
	.ip_flags		resb 2	;"Flags3bit"1=Don’t Fragment,2=More Fragments,3=0, "FragOff13bit"
	.ip_ttl			resb 1
	.ip_protocol		resb 1
	.ip_cksum		resb 2
	.ip_source		resb 4
	.ip_dest		resb 4
	.ip_options		resb 44		;40 + pad
endstruc

struc tcphdr
	.tcp_sport		resb 2
	.tcp_dport		resb 2
	.tcp_seqno		resb 4
	.tcp_ackno		resb 4
	.tcp_hlen		resb 1;4bittcphdr_len,4bitreserved
	.th_flags		resb 1
	.tcp_winsize		resb 2
	.tcp_cksum 		resb 2
	.tcp_urgent		resb 2
	.tcp_options		resb 44
endstruc

struc udphdr
	.sport			resb 2;		/* source port */
	.dport			resb 2;		/* destination port */
	.len			resb 2;		/* udp length */
	.sum			resb 2;		/* udp checksum */
endstruc

struc icmphdr
	.type			resb 1;
	.code			resb 1;
	.sum			resb 2;
	.id			resb 2		;lub 1bajt offset
	.seq			resb 2
	.more			resb 12 ;Timestamps,...max 3 dwordy w zaleznosci od wiadomosci
endstruc

struc igmphdr
	.type			resb 1;
	.code			resb 1;		/* For newer IGMP */
	.csum			resb 2;
	.group			resb 4;
endstruc

struc arphdr
	.ar_hrd			resb 2;		/* format of hardware address	*/
	.ar_pro			resb 2;		/* format of protocol address	*/
	.ar_hln			resb 1;		/* length of hardware address	*/
	.ar_pln			resb 1;		/* length of protocol address	*/
	.ar_op			resb 2;		/* ARP opcode (command)	ARPOP_REQUEST

	.ar_sha			resb 6;/* sender hardware address	*/
	.ar_sip			resb 4;	/* sender IP address		*/
	.ar_tha			resb 6;/* target hardware address	*/
	.ar_tip			resb 4;	/* target IP address		*/
endstruc

struc sockaddr_ll
	.sll_family		resb 2		;
	.sll_protocol		resb 2		;
	.sll_ifindex		resb 4		;eth0 .. 0 1 2
	.sll_hatype		resb 2		;
	.sll_pkttype		resb 1		;
	.sll_halen		resb 1		;
	.sll_addr		resb 8
endstruc








