;ASM ;autor yesma
tcp_packet:
section .data
	.kom_tcp			db "TCP",0ah
	.kom_tcp_len			equ $ - .kom_tcp
section .text
;load tcphdr len
	mov cl,[esi + 12]		;12 bajtow od poczatku tcphdr jest dlugosc
	shr cl,4			;przesuwamy 4bitowe pole na poczatkowe 4bity w bajcie
	shl cl,2			;i mnozymy  * 4 zeby miec dlugosc naglowka w bajtach
	mov [tcp_lenth],cl		;4bity==15, * 4 == 60, max 60 bajtow
mov dl,cl
	mov edi,tcp			;do tcphdr struc tcp_lenth bajtow z buf
	rep movsb			;za naglowkiem tcp znajduja sie przesylane (opcje i) dane
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  TCP options
	cmp dl,20
	ja .sa_opcje
	xor cl,cl			;resetuje opcje poprzedniego pakietu
	mov [tcp_options_ile],cl
	jmp .no_tcp_opt			;jesli wieksze to sa jopcje tcp
.sa_opcje:
	sub dl,20			;odejmuje tcp_hl
	mov [tcp_options_ile],dl
.no_tcp_opt:	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;calculate data len
	mov cx,[ip + iphdr.ip_total_length]	;dlugosc calego odebranego datagramu
	ror cx,8
	xor ah,ah
	mov al,[ip_lenth]
	sub cx,ax
	mov al,[tcp_lenth]
	sub cx,ax
	mov [data_ile],cx		;data len == totalen - iphl - tcphl
	mov [data_pt],esi
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	adr2bin	127,0,0,1
	cmp eax,[ip + iphdr.ip_source]
	jne .not_local
	xor cl,cl			;zerujemy opcje ale chyba niepotrzebne
	mov [ip_options_ile],cl
ret
.not_local:
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ wypelniamy buf do wyswietlenia
	xor ebx,ebx
	mov edi,head_buf
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
	mov esi,.kom_tcp
	mov cx,.kom_tcp_len
	add bx,cx
	rep movsb
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
call write_ethdr
call write_iphdr
call write_tcphdr
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ load data
	mov cx,[data_ile]
	cmp cx,0
	jz .no_data
push cx
	mov esi,kom_data
	mov cx,kom_data_ile
	add bx,cx
	rep movsb
pop cx
	mov esi,[data_pt]
call h2str
.no_data:
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ piszemy caly packet
	mov al,0ah
	stosb
	inc ebx
	mov esi,ebx
	sys_write 1,head_buf,esi
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
